unit main;

interface

uses
    Windows, Messages, SysUtils,
    Classes, Graphics, Controls,
    Forms, Dialogs, StdCtrls,

    http,  // server unit
    JPEG;  // to compress to jpeg

// video messages
// see http://community.borland.com/article/0,1410,16037,00.html
const WM_CAP_START                  = WM_USER;
const WM_CAP_STOP                   = WM_CAP_START + 68;
const WM_CAP_DRIVER_CONNECT         = WM_CAP_START + 10;
const WM_CAP_DRIVER_DISCONNECT      = WM_CAP_START + 11;
const WM_CAP_SAVEDIB                = WM_CAP_START + 25;
const WM_CAP_GRAB_FRAME             = WM_CAP_START + 60;
const WM_CAP_SEQUENCE               = WM_CAP_START + 62;
const WM_CAP_FILE_SET_CAPTURE_FILEA = WM_CAP_START +  20;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
    hWndC : THandle;
  public
    { Public declarations }
    procedure GetPicture(OutputStream : TMemoryStream);
    procedure ConnectToVideoDriver;
  end;

   function capCreateCaptureWindowA(lpszWindowName : PCHAR;
                                    dwStyle : longint;
                                    x : integer;
                                    y : integer;
                                    nWidth : integer;
                                    nHeight : integer;
                                    ParentWin : HWND;
                                    nId : integer): HWND;
                                    STDCALL EXTERNAL 'AVICAP32.DLL';

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
     ConnectToVideoDriver;
     TTCPHttpDaemon.create(Edit2.Text);
     Edit2.Enabled := false;
end;

procedure TForm1.ConnectToVideoDriver;
begin
     // open video
     hWndC := capCreateCaptureWindowA( 'Capture',
                                       WS_CHILD or WS_VISIBLE,
                                       0,
                                       0,
                                       384,
                                       288,
                                       Self.Handle, // a handle to parent window
                                       0);
     if hWndC <> 0 then
     begin
          // driver connect
          SendMessage(hWndC, WM_CAP_DRIVER_CONNECT, 0, 0);
     end;
end;


procedure TForm1.GetPicture(OutputStream : TMemoryStream);
var
   BitmapImage : TBitmap;
   JPEGImage   : TJPEGImage;
   PictureFile : String;
begin
     if hWndC <> 0 then
     begin
          PictureFile := 'snapshot.bmp';
          // grab frame
          SendMessage( hWndC, WM_CAP_GRAB_FRAME, 0, 0);
          // save bmp
          SendMessage( hWndC,
                       WM_CAP_SAVEDIB,
                       0,
                       longint(pchar(PictureFile)));

     end
     else
     begin
          // a bitmap for a case you cannot grab a frame
          PictureFile := 'webcamtrouble.bmp';
     end;

     BitmapImage := TBitmap.Create;
     with BitmapImage, BitmapImage.Canvas do
     begin
          LoadFromFile(PictureFile);
          // date and time
          TextOut(10, 10, DateToStr(Now)
                          + '  '
                          + TimeToStr(Now)
                          + ' EMT');
          // a message
          TextOut(10, 30, ' ' + Edit1.Text + ' ');
          Edit1.Text := ''; // message sent
     end;

     { Assign bitmap to jpeg }
     JPEGImage := TJPEGImage.Create;
     with JPEGImage do
     begin
          Assign(BitmapImage);
          CompressionQuality := 50;
          SaveToStream(OutputStream);
          Free;
     end;

     BitmapImage.Free;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
     if hWndC <> 0 then
     begin
          // close video
          SendMessage(hWndC, WM_CAP_DRIVER_DISCONNECT, 0, 0);
     end;

end;

end.
